<?php
/*
Content Pay by Zong
brought to you by : Zong - http://developer.zong.com
written by: Adrien Kolly (adrien DOT kolly AT echovox DOT com)

Copyright (C) 2008 developer.zong.com 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

        header('Content-type: application/xml');
        require_once('../../../wp-config.php' );
        require_once('../../../wp-includes/wp-db.php' );
        
function generatePassword($length=5,$alphanumeric=1) {  
	$password = '';
	if((string)$alphanumeric==(string)1){
		$vowels = 'aeuyAEUY';
		$consonants = 'bdghjmnpqrstvzBDGHJLMNPQRSTVWXZ23456789';
		$alt = time() % 2;
		for ($i = 0; $i < $length; $i++) {
			if ($alt == 1) {
				$password .= $consonants[(rand() % strlen($consonants))];
				$alt = 0;
			} else {
				$password .= $vowels[(rand() % strlen($vowels))];
				$alt = 1;
			}
		}
	}else{
		$stringchar = '1234567890';
		for ($i = 0; $i < $length; $i++) {
			$password .= $stringchar[(rand() % strlen($stringchar))];
		}
	}
	return $password;
}

function savePassword(){
    global $wpdb;
    $tablePassword = $wpdb->prefix."contentpaybyzong_passwords";
    $optionarray_def = get_option('contentpaybyzong_options');
    $numberOfDay = $optionarray_def['numberOfDay'];
    $passwordLength = (empty($optionarray_def['passwordLength'])) ? "8" : $optionarray_def['passwordLength']; 
    $alphanumeric = (empty($optionarray_def['alphanumeric'])) ? "0" : $optionarray_def['alphanumeric']; 

    $nextDay = time() + $numberOfDay*(24*60*60);
    // Doesn't allow to have twice the same password
    do{
        $password = generatePassword($passwordLength,$alphanumeric); 
        // BINARY  -> case sensitive
        $var = $wpdb->get_results("SELECT id FROM $tablePassword WHERE BINARY password = '$password'");
    }while(!empty($var));
    
    $date = date("Y-m-d H:i:s", $nextDay);
    if(!$wpdb->query("  INSERT INTO $tablePassword (id ,password ,end_date)
                        VALUES (NULL , '$password', '$date')")){
        error_log('contentpaybyzong -'.strftime("%d %b %Y %H:%M:%S ").'-'.'Failed to add the password in the database. msisdn was '.$_GET['msisdn']);
    }
    return $password;
}

// IP Address of the simulator 
if($_SERVER['REMOTE_ADDR'] == '84.16.77.1' OR $_SERVER['HTTP_X_FORWARDED_FOR'] == '84.16.77.1'){
// if(true){
    $password = savePassword();
}else{
    $password = "Access denied!";
}

error_log('contentpaybyzong -'.strftime("%d %b %Y %H:%M:%S ").'-'.$_SERVER['REMOTE_ADDR'].'//'.$_SERVER['HTTP_X_FORWARDED_FOR']. '- password: '.$password);

echo '<?xml version="1.0" encoding="UTF-8" ?>
<oneoff_response fragmentable="false" reverse_charged="true">
    <text_content>Your password: '.$password.'</text_content>
</oneoff_response>';



